#include <algorithm>
#include <cstdlib>
#include <fstream>
#include <vector>
#include <queue>
#include <set>
#include <map>

int main(int argc, char *argv[]) {
	//...
	long nrow = atol(argv[1]), ncol = atol(argv[2]), ntop = atol(argv[3]), seed = atol(argv[4]); srand(seed);
	//...
	std::vector<std::pair<int, int> > STOP, USED;
	//...
	for (int yes, f, l, j, i = 0; i < nrow; ++ i) {
		switch (i % 4) {
			case 0: l = 2; f = 5; break;
			case 1: l = 0; f = 5; break;
			case 2: l = 1; f = 3; break;
			case 3: l = 4; f = 5; break;
		}
		for (j = 0; j < ncol; ++ j) {
			if (l == f) { f = (f != 5)? (5): (3); l = 0; }
			if (seed % 2)
				yes = ((i < nrow - 1) && (i > 0) &&
				       (j < ncol - 1) && (j > 0));
			else {
				yes = (j < ncol - 1);
			}
			if (yes && (f == 3))
				STOP.push_back({i, j});
			else {
				USED.push_back({i, j});
			}
			++ l;
		}
	}
	//...
	std::random_shuffle(begin(STOP), end(STOP));
	std::ofstream fid("input.txt"); fid << nrow << "\t" << ncol << "\n";
	fid << STOP.size() << "\n";
	for (int i = 0; i < STOP.size(); ++ i) {
		fid << STOP[i].first << "\t" << STOP[i].second << "\n";
	}
	fid << ntop << "\n";
	int k = 0;
	fid << USED[k].first << "\t" << USED[k].second << "\n";
	for (int i = 1; i < ntop; ++ i) {
		k = (k + rand() % (USED.size() - 1)) % USED.size();
		fid << USED[k].first << "\t";
		fid << USED[k].second;
		fid << "\n";
	}
	//...
	return 0;
}
