#include <fstream>
#include <vector>
#include <queue>

int main() {
	//...
	std::vector<std::pair<int, int> > PATH; std::ifstream finp("input.txt"); int row, col, ans, k, a, b, c, d;
	finp >> row >> col;
	std::vector<std::vector<int> > STOP(row, std::vector<int> (col, false));
	std::vector<std::vector<int> > USED(row, std::vector<int> (col, false));
	finp >> k;
	while (k --) { finp >> a >> b; STOP[a][b] = true; }
	finp >> k;
	while (k --) {
		finp >> a >> b; PATH.push_back({a, b});
	}
	//...
	ans = 0;
	for (int i = 1; i < PATH.size(); ++ i) {

		for (int i = 0; i < row; ++ i) for (int j = 0; j < col; ++ j) USED[i][j] = false;

		std::queue<std::pair<std::pair<int, int>, int> > LIST;
		LIST.push({PATH[i - 1], ans});
		USED[PATH[i - 1].first][PATH[i - 1].second] = true;

		while (LIST.size()) {
			auto cur = LIST.front();
			int b = cur.first.second, a = cur.first.first, l = cur.second;
			if (ans < l) ans = l;
			if ((b == PATH[i].second) && (a == PATH[i].first)) break;
			LIST.pop();
			static const int move[][8] = {
				{-2, -1, +1, +2, +2, +1, -1, -2},
				{+1, +2, +2, +1, -1, -2, -2, -1}
			};
			for (int k = 0; k < 8; ++ k) {
				c = a + move[0][k]; d = b + move[1][k];
				if ((c < 0) || (c >= row) ||
				    (d < 0) || (d >= col) ||
				    STOP[c][d] ||
				    USED[c][d]) continue;
				USED[c][d] = true;
				LIST.push(
				{{c, d}, l + 1}
				);
			}
		}
		if (!USED[PATH[i].first][PATH[i].second]) {
			ans = -1;
			break;
		}
	}
	//...
	std::ofstream fout("output.txt");
	fout << ans;
	//...
	return 0;
}
