#include <algorithm>
#include <cstdlib>
#include <fstream>
#include <vector>
#include <queue>
#include <set>
#include <map>

int main(int argc, char *argv[]) {
	//...
	long nrow = atol(argv[1]), ncol = atol(argv[2]);
	long nbar = atol(argv[3]), ntop = atol(argv[4]), seed = atol(argv[5]); srand(seed);
	//...
	std::vector<std::pair<int, int> > STOP, USED;
	//...
	int tmp = nbar;
	for (int i = 0; i < nrow; ++ i) for (int j = 0; j < ncol; ++ j) {
		if ((rand() % 10 < 3) && tmp) {
			STOP.push_back({i, j}); -- tmp;
		}
		else {
			USED.push_back({i, j});
		}
	}
	while (tmp --) {
		int k = rand() % USED.size();
		STOP.push_back(USED[k]);
		USED[k] = USED.back();
		USED.pop_back();
	}
	//...
	std::random_shuffle(begin(STOP), end(STOP));
	std::ofstream fid("input.txt"); fid << nrow << "\t" << ncol << "\n";
	fid << STOP.size() << "\n";
	for (int i = 0; i < STOP.size(); ++ i) {
		fid << STOP[i].first << "\t" << STOP[i].second << "\n";
	}
	std::random_shuffle(begin(USED), end(USED));
	fid << ntop << "\n";
	int k = 0;
	fid << USED[k].first << "\t" << USED[k].second << "\n";
	for (int i = 1; i < ntop; ++ i) {
		k = (k + rand() % (USED.size() - 1)) % USED.size();
		fid << USED[k].first << "\t";
		fid << USED[k].second;
		fid << "\n";
	}
	//...
	return 0;
}
